SuperStrict
Framework brl.blitz
Import brl.max2d
Import brl.d3d7max2d
Import brl.filesystem
Import brl.retro
Import brl.glmax2d
Import brl.Graphics
Import brl.timer
Import brl.system
Import brl.jpgloader

SeedRnd MilliSecs()

Include "tank_unit.bmx"
AppTitle="worst Tanks Clone"
Const CONFIG_FILE_NAME$="config.ini",MAX_STANDARD_WEAPONS:Byte=1

Global timer:TTimer=CreateTimer(55)
Global config_driver:Byte=0
Global config_width:Short=800
Global config_height:Short=600
Global wind%=0,hgimage:TImage,money:Short=0
Local datei:TStream


If FileType(CONFIG_FILE_NAME)<>1 Or FileSize(CONFIG_FILE_NAME)=0 Then
	datei=WriteFile(CONFIG_FILE_NAME)
	WriteLine datei,"driver=directx"
	CloseFile datei
	SetGraphicsDriver D3D7Max2DDriver()
Else
	datei=ReadFile(CONFIG_FILE_NAME)
	ReadInParameters(datei,config_driver,config_width,config_height)
	If config_driver=1 Then
		SetGraphicsDriver GLMax2DDriver()
	ElseIf config_driver=0 Then
		SetGraphicsDriver D3D7Max2DDriver()
	EndIf
	CloseFile datei
EndIf
Global playerlist:TList=CreateList(),current_player:TPlayer

Graphics config_width,config_height
SetBlend ALPHABLEND

Global base:Short[config_width],base_color%=$FFFFFF
Global standard_weapon:TWeapon[MAX_STANDARD_WEAPONS]
For Local i:Byte=0 To MAX_STANDARD_WEAPONS-1
	standard_weapon[i]=New TWeapon
Next
standard_weapon[0].init("small missile",10,10,10)
LoadHGImage()
selection()
SetClsColor 100,100,200
InitTanks(1)
Repeat
	game()
	Shop()
Forever
End


Function ControlAppargs()
	For Local c$=EachIn AppArgs[1..]
		If c="netbook" Then config_width=640;config_height=480
	Next
EndFunction




Function game()
	'CreateTerrain(Rand(1,3))
	createterrain(3)
	Local rounds:Short
	InitTanks()
	Local weapon:TWeapon
	money=0
	Repeat
		For current_player=EachIn playerlist
			If current_player.tank.maxpower<=0 Then Continue
			If HasOneWon(playerlist) Then Exit
			If current_player.tank.maxpower+current_player.tank.energy<=100 Then current_player.tank.maxpower:+current_player.tank.energy
			rounds:+1
			'Print current_player.name
			wind:+Rand(-4,4)
			If wind>7 Then
				wind=7-Rand(4,7)
			ElseIf wind<7 Then
				wind=-7+Rand(4,7)				
			EndIf
			'Print wind
			DrawEverything()
			Repeat
				If current_player.tank.maxpower<=0 Then Exit
				If KeyHit(KEY_ESCAPE) Or AppTerminate() Then End
				If KeyDown(KEY_LEFT) Then
					current_player.tank.drive(1)
					DrawEverything()
				ElseIf KeyDown(KEY_RIGHT) Then
					current_player.tank.drive(2)
					DrawEverything()
				ElseIf KeyDown(KEY_UP) Then
					current_player.tank.turn(1)
					DrawEverything()
				ElseIf KeyDown(KEY_DOWN) Then
					current_player.tank.turn(2)
					DrawEverything()
				ElseIf KeyDown(KEY_A) And current_player.tank.power>=1 Then
					current_player.tank.power:-1
					DrawEverything()
				ElseIf KeyDown(KEY_S) And current_player.tank.power<=current_player.tank.maxpower Then
					current_player.tank.power:+1
					DrawEverything()
				ElseIf KeyHit(KEY_F2) Then
					DrawEverything()
				EndIf
				WaitTimer timer
			Until KeyHit(KEY_SPACE)
			If current_player.tank.maxpower>0 Then
				TWeapon(current_player.tank.weaponlist.ValueAtIndex(current_player.tank.current_weapon)).shoot(current_player.tank.x,current_player.tank.y,current_player.tank.angle,current_player.tank.power)
			EndIf
			WaitTimer timer
		Next
	Until HasOneWon(playerlist)
	rounds=rounds/playerlist.count()
	money=10*rounds^2/GetWinner().tank.maxpower
	GetWinner().money:+money
	Trostpreise()
EndFunction

Function GetWinner:TPlayer()
	For Local a:TPlayer=EachIn playerlist
		If a.tank.maxpower>0 Then Return a
	Next
	Return Null
EndFunction

Function Trostpreise()
	Local part%=money/playerlist.count()/2.0
	For Local a:TPlayer=EachIn playerlist
		If a.tank.maxpower<=0 Then a.money:+part
	Next
EndFunction

Function DrawEverything(variante:Byte=0)
	Cls
	DrawTerrain()
	DrawPlayers(playerlist)
	DrawBar()
	If variante=0 Then Flip 0
EndFunction

Function DrawPlayers(playerlist:TList)
	For Local a:TPlayer=EachIn playerlist
		a.tank.draw()
	Next
EndFunction


Function DrawBar()
	SetColor 50,100,200
	DrawRect 0,config_height-40,config_width,40
	SetColor 0,0,0
	DrawText "Winkel: ",255,config_height-35
	DrawText (180-((current_player.tank.angle+180) Mod 360)),320,config_height-35
	DrawText "Kraft: ",255,config_height-20
	DrawText "Name:",5,config_height-35
	DrawText current_player.name,60,config_height-35
	DrawText "Leben:",5,config_height-20
	DrawRect 319,config_height-21,102,17
	DrawRect 59,config_height-21,102,17
	DrawText "Wind",465,config_height-35
	DrawText wind,465,config_height-20
	SetColor 255,0,0
	SetAlpha 0.5
	DrawRect 320,config_height-20,current_player.tank.maxpower,15
	SetAlpha 0.8
	DrawRect 320,config_height-20,current_player.tank.power,15
	DrawRect 60,config_height-20,current_player.tank.maxpower,15
	SetAlpha 1
EndFunction



Type TPlayer
	Field name$
	Field tank:TTank
	Field money%
	Field com:Byte 'Wird der Tank von einem Computer kontrolliert?
	
	Function Create:TPlayer(n$,c:Byte=0)
		Local pl:TPlayer=New TPlayer
		Local t:TTank=TTank.Create()
		pl.name=n
		pl.money=0
		pl.com=c
		pl.tank=t
		Return pl
	EndFunction
	
End Type

Type TTank
	Field x#,y#
	Field angle:Short=290
	Field maxpower# 'Leben und maximale Schusskraft
	Field power:Byte 'Schusskraft
	Field fuel#
	Field hillmove:Byte=1
	Field engine:Byte=6
	Field energy:Byte=1
	Field current_weapon%=0
	Field weaponlist:TList=CreateList()
	
	Function Create:TTank()
		Return New TTank
	EndFunction
	
	Method init(typ:Byte=0) '0=innerhalb eines Spiels(kein Zurcksetzen von upgrade-sachen)
		Self.maxpower=100
		Self.power=50
		Self.x=Rand(0,config_width-1)
		'Print "X: "+x+"     BASE: "+base[x]
		Self.fuel=250
		Self.y=base[Self.x]
		If typ<>0 Then
			Self.energy=1
			Self.hillmove=1
			Self.engine=6
			weaponlist.clear()
			weaponlist.AddLast(standard_weapon[0])
		EndIf
	EndMethod
	
	Method draw()
		If Self.maxpower>=1 Then
			If current_player.tank<>Self Then
				SetColor 120,130,140
			Else
				SetColor 120,190,100
			EndIf
			DrawRect x-8,y-10,16,10
			SetColor 0,0,0
			DrawLine x,y-5,x+Cos(angle)*7,y+Sin(angle)*7-5
			DrawLine x+1,y-5,x+Cos(angle)*7,y+Sin(angle)*7-5
		EndIf
	EndMethod
	
	Method turn(dir:Byte) '1=LEFT, 2=RIGHT
		If dir=1 Then
			If angle>180 Then angle:-1
		ElseIf dir=2 Then
			If angle<359 Then angle:+1
		EndIf
	EndMethod
	
	Method drive(dir:Byte)' 1=LEFT, 2=RIGHT
		If fuel>0 Then
			If (dir=1 And (y-base[x-1])>Sqr(hillmove)*2.4) Or (dir=2 And (y-base[x+1])>Sqr(hillmove)*2.4) Then Return
			If Not ((dir=1 And x<=0) Or (dir=2 And x>=config_width-1)) Then 
				x=x-(dir=1)*0.5+(dir=2)*0.5
			EndIf
			Self.y=base[x]
			fuel=fuel-engine/8.0
		EndIf
	EndMethod
	
EndType

Type TWeapon
	Field name$
	Field power:Byte 'Zerstrungskraft
	Field startpower:Byte
	Field amount:Byte
	Field x_radius:Byte 'Bereich auf der X-Achse in dem die Waffe wirkt
	Field y_radius:Byte 'Bereich auf der Y-Achse in dem die Waffe wirkt
	
	Method init(n$,p:Byte,x:Byte,y:Byte,a:Byte=99)
		Self.name=n
		Self.power=p
		Self.startpower=p
		Self.x_radius=x
		Self.y_radius=y
		Self.amount=a
	EndMethod
	
	Method shoot(x:Short,y:Short,angle:Short,shoot_power:Byte)
		If amount=0 Then Return
		If amount<99 Then amount:-1
		Local ball:TBall=TBall.Create(x,y,angle,power,shoot_power,x_radius,y_radius)
		Local g:Byte
		Repeat
			DrawEverything(1)
			g=ball.calc()
			ball.draw()
			Flip 0
			WaitTimer timer
		Until g=0
	EndMethod
End Type

Type TBall
	Field x#,y#,angle:Short,t#=1
	Field power#,power2:Byte
	Field weaponpower:Byte
	Field x_rad:Byte
	Field y_rad:Byte
	Function Create:TBall(ex:Short,ey:Short,eangle:Short,wp:Byte,epower:Byte,xr:Byte,yr:Byte)
		Local ball:TBall=New TBall
		ball.x=ex+Cos(eangle)*11
		ball.y=ey+Sin(eangle)*7-5
		ball.angle=eangle
		ball.power=epower
		ball.power2=epower
		ball.weaponpower=wp
		ball.x_rad=xr
		ball.y_rad=yr
		Return ball
	EndFunction
	Method calc:Byte() '2 ... Schuss im Gang , 0 ... Schuss-Sequenz beendet
		t:+0.01
		If Self.x>=config_width-1 Or Self.x<0 Then Return 0
		If Self.y>=base[Self.x] Or Collided(x,y) Then 
			Self.explode()
			Return 0
		EndIf
		x:+4.0*Sqr(power2)*Cos(angle)/3.0+wind/8.0
		If power>0 Then 
			y:+4.0*Sqr(power)*Sin(angle)/3.0
		ElseIf power<0 Then
			y:+ 4.0*-Sqr(-power)*Sin(angle)/3.0
		EndIf
		y:+4*t^2
		'y:+(600-y)^(1.0/4.0)
		'y:+(600-y)/64.0
		''''power:-(power2/120.0)
		'power:-0.5
		Return 2
	EndMethod
	Method draw()
		SetColor 0,0,0
		DrawOval x-2,y-2,4,4
	EndMethod
	Method explode()
		Local by:Short
		If x-x_rad/2.0>=0 And x+x_rad/2.0<=config_width-1 Then
			For Local lx:Short=x-x_rad/2.0 To x+x_rad/2.0
				If base[lx]<y+(y_rad/2.0) Then base[lx]=y+(y_rad/2.0)
			Next
		ElseIf x-x_rad/2.0<0 Then
			For Local lx:Short=0 To x+x_rad/2.0
				If base[lx]<y+(y_rad/2.0) Then base[lx]=y+(y_rad/2.0)
			Next			
		ElseIf x+x_rad/2.0>=config_width Then
			For Local lx:Short=x-x_rad/2.0 To config_width-1
				If base[lx]<y+(y_rad/2.0) Then base[lx]=y+(y_rad/2.0)
			Next				
		EndIf
		Local maxdist#=Sqr((x_rad/2.0)^2+(y_rad/2.0)^2)
		For Local a:TPlayer=EachIn playerlist
			If a.tank.x>=x-x_rad/2.0-8 And a.tank.x<=x+x_rad/2.0+8 And a.tank.y>=y-y_rad/2.0-6 And a.tank.y<=y+y_rad/2.0+8 Then
				a.tank.maxpower:-Float(weaponpower)/a.tank.energy
				If a.tank.power>a.tank.maxpower Then a.tank.power=a.tank.maxpower-2
				If a.tank.maxpower<=0 Then
					a.tank.power=0
					a.tank.maxpower=0
					For Local i%=250 To 50 Step -50
						Cls
						DrawEverything(1)
						SetColor 255,i,0
						DrawOval a.tank.x-15,a.tank.y-15,30,30
						Flip 0
						WaitTimer timer
					Next
					Delay 50
				EndIf
			EndIf
		Next
		RepositionTanks()
	EndMethod
EndType

Function Collided:Byte(x:Short,y:Short)
	For Local a:TPlayer=EachIn playerlist
		If x>=a.tank.x-8 And y>=a.tank.y-6 And x<=a.tank.x+8 And y<=a.tank.y+6 Then Return 1
	Next
	Return 0
EndFunction

Function GetDistance#(x1:Short,y1:Short,x2:Short,y2:Short)
	Return Sqr((x1-x2)^2+(y1-y2)^2)
EndFunction